/*************************************************************************************
 * DeviceOne JavaScript Library
 * Version 5.0.0
 * Author : nanyuantingfeng
 *************************************************************************************/
window.deviceone = (function (_ENV,undefined) {
    "use strict";
    var L, R, Fk, Fi, ME, M2, J2, I0, BA, BP, Class, DP, DM, d1, C, cc, E, Q, UI, SM, MM;L = {
    _0_ : function(m, e, p) { return _ENV.external._do_ui_sync_invoke(m, e, p); },
    _1_ : function(m, e, p, u) { return _ENV.external._do_ui_async_invoke(m, e, p, u); },
    _2_ : function(m, e, p) { return _ENV.external._do_sm_sync_invoke(m, e, p); },
    _3_ : function(m, e, p, u) { return _ENV.external._do_sm_async_invoke(m, e, p, u); },
    _4_ : function(m, e, p) { return _ENV.external._do_mm_sync_invoke(m, e, p); },
    _5_ : function(m, e, p, u) { return _ENV.external._do_mm_async_invoke(m, e, p, u); },
    _6_ : function(m, e, p) { return _ENV.external._do_mm_createnew(m, e, p); },
    _7_ : function(m) { return _ENV.external._do_mm_release(m); },
    _8_ : function(m, s) { return _ENV.external._do_print(m, s); }
};R = {
        h : function(a, b) { return Object.prototype.hasOwnProperty.call(a, b); },
        r : function(k) { return {get : function() { return this.get(k); }, enumerable : true, configurable : true} },
        w : function(k) { return {get : function() { return this.get(k); }, set : function(v) { return this.set(k, v); }, enumerable : true, configurable : true} },
        p : function(a, b) {
            Object.defineProperties(a, b);
            return a;
        },
        a : function(a) { return Array.apply(null, a); },
        y : function(a) { return Array.isArray(a); },
        l : function(a, b) { return L._8_(String(a), String(b)); }
    };
    Fk = function(m, f) {
        var k;
        for(k in m) if(R.h(m, k)) if(f.call(m[k], k, m[k]) === false) break;
        return m;
    };
    Fi = function(m, f) {
        var i = 0, l = m.length;
        m = m || [];
        for(; i < l; i++)  if(f.call(m[i], i, m[i]) === false)  break;
        return m;
    };
    I0 = function(m) {
        if(m === null || m === undefined) return false;
        return typeof m === "object";
    };
    ME = function() {
        var arg, t, u, k;
        arg = R.a(arguments);
        t = arg.shift();
        if(!t) t = {};
        u = arg.shift();
        if(!u) return t;
        for(k in u)  if(R.h(u, k))  t[k] = u[k];
        arg.unshift(t);
        return ME.apply(null, arg);
    };
    M2 = function(s) {
        var c;
        if(typeof s !== "string") return s;
        var s1 = s.trim();
        c = s1.charCodeAt(0);
        if(c == 123 || c == 91) { try {var s2 = JSON.parse(s1); return s2; } catch(e) {}}
        return s;
    };
    J2 = function(t) {
        if(I0(t))  return JSON.stringify(t);
        return t;
    };
    BA = function(o) {
        if(I0(o) && o._do_addressN) return o._do_addressN();
        return o;
    };
    BP = function(ags, als) {
        var o, i, l, k, v, ast;
        if(ags === o || als === o)  return "";
        ast = BA(ags[0]);
        if(ast && I0(ast) && R.h(ast, als[0])) {
            for(k in ast) if(R.h(ast, k)) ast[k] = BA(ast[k]);
            return ast;
        }
        i = 0, l = als.length, o = {};
        for(; i < l; i++) {
            v = ags[i];
            if(typeof v === "function") break; else o[als[i]] = BA(v);
        }
        return o;
    };
    Class = function(Super, init) {
        var NEW, N;
        N = function() {};
        init = init || N;
        N.prototype = Super.prototype;
        NEW = function() { return new NEW.fn.initialize(arguments); };
        NEW.fn = NEW.prototype = new N();
        NEW.fn.initialize = function(args) {
            init.apply(this, args);
            return this;
        };
        NEW.fn.constructor = NEW;
        NEW.fn.initialize.prototype = NEW.fz = NEW.fn;
        NEW.initialize = init;
        return NEW;
    };
    DP = function(fn, ro, rw) {
        var fnn = {};
        ro.forEach(function(v) { fnn[v] = R.r(v); });
        rw.forEach(function(v) { fnn[v] = R.w(v); });
        return R.p(fn, fnn);
    };
    DM = function(fn, ms, ma) {
        Fk(ms, function(k, v) { fn[k] = function() { return this._do_synchrN(k, arguments, v); }; });
        Fk(ma, function(k, v) { fn[k] = function() { return this._do_asynchN(k, arguments, v); }; });
        return fn;
    };
    d1 = {Class : Class, foreach : Fk, foreachi : Fi, merge : ME, print : R.l};
    C = Class(R, function() {
        this._S_ = {};
        this._F_ = {};
        this._E_ = {};
    });
    ME(C.fn, {
        uid : (function() {
            var _uux = 0xFFFFEEEF;
            return function() { return ( ++_uux ).toString(); };
        }()),
        reg : function(s, e, m, f) {
            var g = {e : e, u : "-"}, u, q;
            if(typeof f !== "function") return g;
            u = this.uid();
            this._S_[u] = s;
            this._F_[u] = f;
            g.u = u;
            if(e !== "on")  return g;
            q = s._do_uniqueN;
            this._E_[q] = this._E_[q] || {};
            this._E_[q][m.name] = this._E_[q][m.name] || [];
            this._E_[q][m.name].push(u);
            return g;
        },
        del : function(u) {
            this._F_[u] = undefined;
            this._S_[u] = undefined;
            delete this._F_[u];
            delete this._S_[u];
            return this;
        },
        ivk : function(r) {
            var g = M2(r.callback);
            var f = this._F_[g.u];
            if(f) f.call(this._S_[g.u], M2(r.data), {code : r.code, message : r.message, data : M2(r.eventdata), sender : r.sender}, this._S_[g.u]);
            if(g.e !== "on") this.del(g.u);
            return this;
        },
        off : function(s, e) {
            var q = s._do_uniqueN, se, i, l;
            if(this._E_[q]) {
                if(this._E_[q][e]) {
                    se = this._E_[q][e];
                    i = 0, l = se.length;
                    for(; i < l;) this.del(se[i++]);
                }
                this._E_[q][e] = undefined;
                delete this._E_[q][e];
            }
            return s;
        },
        uis : function(s, e, m) { return M2(M2(L._0_(s._do_uniqueN, e, J2(m))).data); },
        uia : function(s, e, m, f) {
            L._1_(s._do_uniqueN, e, J2(m), J2(this.reg(s, e, m, f)));
            return s;
        },
        sms : function(s, e, m) { return M2(M2(L._2_(s._do_uniqueN, e, J2(m))).data); },
        sma : function(s, e, m, f) {
            L._3_(s._do_uniqueN, e, J2(m), J2(this.reg(s, e, m, f)));
            return s;
        },
        mms : function(s, e, m) { return M2(M2(L._4_(s._do_uniqueN, e, J2(m))).data); },
        mma : function(s, e, m, f) {
            L._5_(s._do_uniqueN, e, J2(m), J2(this.reg(s, e, m, f)));
            return s;
        },
        mmn : function(s, e, m) { return M2(L._6_(s, e, m)).data; },
        mmd : function(s) { return L._7_(s._do_uniqueN); },
        err : function(s) { return L._8_(s, "ERROR"); }
    });
    cc = C();
    _ENV._do_async_callback = function(r) { cc.ivk(M2(r)); };
    E = Class(R);
    ME(E.fn, {
        on : function() { return this._do_asynchN("on", arguments, ["name", "data", "delay"]); },
        off : function() {
            this._do_synchrN("off", arguments, ["name"]);
            return cc.off(this, arguments[0]);
        },
        fire : function() { return this._do_synchrN("fire", arguments, ["name", "data"]); },
        getAddress : function() { return this._do_synchrN("getAddress"); },
        getType : function() { return this._do_synchrN("getType"); },
        _do_addressN : function() { return this._do_uniqueN; }
    });
    Q = Class(E);
    ME(Q.fn, {
        get : function() {
            var arg = R.a(arguments);
            var flg = !R.y(arg[0]);
            if(flg) arg[0] = [arg[0]];
            var _n = this._do_synchrN("get", arg, ["data"]);
            if(_n === null || _n === undefined) return cc.err("Failed to get properties" + J2(arg));
            if(flg) _n = _n[arg[0][0]];
            return _n;
        },
        set : function() {
            var arg = arguments, kv = {};
            if(arg.length >= 2) kv[arg[0]] = BA(arg[1]); else kv = arg[0];
            return this._do_synchrN("set", [kv], ["data"]);
        },
        bindData : function() { return this._do_synchrN("bindData", arguments, ["data", "mapping"]) },
        setMapping : function() { return this._do_synchrN("setMapping", arguments, ["data"]) },
        refreshData : function() {return this._do_synchrN("refreshData") }
    });
    UI = Class(Q), SM = Class(E), MM = Class(Q);
    d1.UI = UI, d1.SM = SM, d1.MM = MM;
    DP(UI.fn, ["id"], ["width", "height", "x", "y", "visible", "alpha", "bgColor", "tag", "margin", "border"]);
    ME(UI.fn, {
        animate : function() { return this._do_asynchN("animate", arguments, ["animation"]); },
        remove : function() { return this._do_synchrN("remove"); },
        redraw : function() { return this._do_synchrN("redraw"); },
        getRect : function() { return this._do_synchrN("getRect"); },
        show : function() { return this._do_asynchN("show", arguments, ["animationType", "animationTime"]); },
        hide : function() { return this._do_asynchN("hide", arguments, ["animationType", "animationTime"]); },
        _do_synchrN : function(e, a, l) { return cc.uis(this, e, BP(a, l)); },
        _do_asynchN : function(e, a, l) { return cc.uia(this, e, BP(a, l), a[a.length - 1]); }
    });
    ME(SM.fn, {
        _do_synchrN : function(e, a, l) { return cc.sms(this, e, BP(a, l)); },
        _do_asynchN : function(e, a, l) { return cc.sma(this, e, BP(a, l), a[a.length - 1]); }
    });
    ME(MM.fn, {
        load : function() { return this._do_asynchN("load", arguments, ["source"]); },
        loadSync : function() { return this._do_synchrN("loadSync", arguments, ["source"]); },
        release : function() { return cc.mmd(this); },
        _do_synchrN : function(e, a, l) { return cc.mms(this, e, BP(a, l)); },
        _do_asynchN : function(e, a, l) { return cc.mma(this, e, BP(a, l), a[a.length - 1]); }
    });
    d1.ui = function(m) {
        var a4 = cc.uis({_do_uniqueN : m}, "getInit", "");
        if(!a4) return cc.err("Failed to get information [" + m + "]");
        if(!UI[a4.type]) return cc.err("Class UI." + a4.type + " has not been defined");
        return UI[a4.type](a4);
    };
    d1.sm = function(m) {
        if(!SM[m]) return cc.err("Class SM." + m + " has not been defined");
        return SM[m]();
    };
    d1.mm = function(m, i, c) {
        if(!MM[m]) return cc.err("Class MM." + m + " has not been defined");
        return MM[m](BA(i || ""), BA(c || ""));
    };
    UI.df = function(n, ro, rw, ms, ma) {
        UI[n] = Class(UI, function(a4) { this._do_uniqueN = a4.address});
        DM(DP(UI[n].fn, ro, rw), ms, ma);
    };
    SM.df = function(n, ms, ma) {
        SM[n] = Class(SM, function() { this._do_uniqueN = cc.sms({_do_uniqueN : n}, "getAddress", "")});
        DM(SM[n].fn, ms, ma);
    };
    MM.df = function(n, ro, rw, ms, ma) {
        MM[n] = Class(MM, function(i, c) { this._do_uniqueN = cc.mmn(n, i, c)});
        DM(DP(MM[n].fn, ro, rw), ms, ma);
    };UI.df("do_ALayout",["isStretch","layoutAlign"],["bgImage","bgImageFillType","enabled"],{"add":["id","path","x","y"],"getChildren":[]},{});SM.df("do_Album",{},{"save":["path","name","width","height","quality"],"select":["maxCount","width","height","quality","iscut"]});SM.df("do_Alipay",{},{"pay":["rsaPrivate","rsaPublic","partner","notifyUrl","tradeNo","subject","sellerId","totalFee","body","timeOut"]});MM.df("do_Animation",[],["fillAfter"],{"alpha":["data","id"],"rotate":["data","id"],"scale":["data","id"],"transfer":["data","id"]},{});MM.df("do_Animator",[],[],{"append":["duration","props","curve"]},{});SM.df("do_App",{"getAppID":[]},{"closePage":["data","animationType","layer"],"closePageToID":["data","animationType","id"],"openPage":["source","data","animationType","keyboardMode","scriptType","statusBarState","statusBarFgColor","statusBarBgColor","id"],"update":["source","target"]});MM.df("do_Bitmap",[],[],{"getExif":["source"]},{"loadFile":["source"],"save":["format","quality","outPath"],"toFrostedGlass":["degree"],"toGrayScale":[],"toRoundCorner":["radius"]});UI.df("do_Button",["radius","textFlag"],["bgImage","enabled","fontColor","fontSize","fontStyle","text"],{},{});SM.df("do_CacheManager",{},{"clearImageCache":[],"getImageCacheSize":[]});SM.df("do_Camera",{},{"capture":["width","height","quality","iscut","facingFront","outPath"]});UI.df("do_CheckBox",["textFlag"],["checked","enabled","fontColor","fontSize","fontStyle","text"],{},{});SM.df("do_DataCache",{"hasData":["key"],"loadData":["key"],"removeAll":[],"removeData":["key"],"saveData":["key","value"]},{});SM.df("do_Device",{"beep":[],"flash":["status"],"getAllAppInfo":[],"getBattery":[],"getInfo":[],"getLocale":[],"home":[],"setScreenAutoDarken":["isAuto"],"vibrate":["duration"]},{"getGPSInfo":[],"getRingerMode":[],"screenShot":["rect"],"srceenShotAsBitmap":["rect","bitmap"]});SM.df("do_External",{"bulkSMS":["number","body"],"existApp":["key"],"installApp":["path"],"openApp":["wakeupid","data"],"openContact":[],"openDial":["number"],"openFile":["path"],"openMail":["to","subject","body"],"openSMS":["number","body"],"openSystemSetting":["type"],"openURL":["url"]},{});UI.df("do_FrameAnimationView",[],[],{"startGif":["data","repeat"],"startImages":["data","repeat"],"stop":[]},{});SM.df("do_Global",{"exit":[],"getFromPasteboard":[],"getMemory":["key"],"getSignatureInfo":[],"getTime":["format"],"getVersion":[],"getWakeupID":[],"setMemory":["key","value"],"setToPasteboard":["data"]},{"install":["src"]});UI.df("do_GridView",["canScrollToTop","headerView","hSpacing","isHeaderVisible","isShowbar","selectedColor","templates","vSpacing"],["items","numColumns"],{"bindItems":["data"],"rebound":[],"refreshItems":["indexs"]},{});MM.df("do_Http",[],["body","contentType","method","responseEncoding","timeout","url"],{"download":["path"],"download1":["path","taskId","isBreakpoint"],"form":["data"],"getResponseHeader":["key"],"request":[],"setRedirect":["isSetRedirect"],"setRequestHeader":["key","value"],"stopDownload":["taskId"],"upload":["path","name"]},{});UI.df("do_ImageCropView",[],["cropArea","source"],{},{"crop":[]});UI.df("do_ImageView",["cacheType","radius","scale"],["animation","defaultImage","enabled","source"],{"setBitmap":["bitmap"]},{});UI.df("do_Label",["maxHeight","maxLines","maxWidth","textAlign"],["fontColor","fontSize","fontStyle","linesSpace","text","textFlag"],{},{});UI.df("do_LinearLayout",["direction","padding"],["bgImage","bgImageFillType","enabled"],{"add":["id","path","target"],"getChildren":[]},{});MM.df("do_ListData",[],[],{"addData":["data","index"],"addOne":["data","index"],"getCount":[],"getData":["indexs"],"getOne":["index"],"getRange":["fromIndex","toIndex"],"removeAll":[],"removeData":["indexs"],"removeRange":["fromIndex","toIndex"],"updateOne":["index","data"]},{});UI.df("do_ListView",["canScrollToTop","footerView","headerView","isFooterVisible","isHeaderVisible","isShowbar","selectedColor"],["bounces","templates"],{"bindItems":["data"],"rebound":[],"refreshItems":[],"scrollToPosition":["position","isSmooth"],"showHeader":[]},{});SM.df("do_Notification",{"toast":["text","x","y"]},{"alert":["text","title"],"confirm":["text","title","button1text","button2text"]});SM.df("do_Page",{"getData":[],"hideKeyboard":[],"remove":["id"],"supportPanClosePage":["data","support"]},{});UI.df("do_ProgressBar",["style"],["progress"],{},{});SM.df("do_QRCode",{},{"create":["text","length"],"recognition":["path"]});UI.df("do_ScrollView",["canScrollToTop","direction","headerView","isHeaderVisible","isShowbar"],[],{"rebound":[],"scrollTo":["offset"],"toBegin":[],"toEnd":[]},{"screenShot":[]});UI.df("do_SegmentView",["templates"],["index"],{"bindItems":["data"],"refreshItems":[]},{});UI.df("do_SlideView",["allowGesture","isAllCache","looping","templates"],["index"],{"bindItems":["data"],"getView":["index"],"refreshItems":[],"startLoop":["interval"],"stopLoop":[]},{});SM.df("do_Storage",{"dirExist":["path"],"fileExist":["path"],"getFileSize":["path"],"readFileSync":["path","isSecurity","encoding"]},{"copy":["source","target"],"copyFile":["source","target"],"deleteDir":["path"],"deleteFile":["path"],"getDirs":["path"],"getFiles":["path"],"readFile":["path","isSecurity","encoding"],"unzip":["source","target"],"writeFile":["path","data","isSecurity","encoding"],"zip":["source","target"],"zipFiles":["source","target"]});SM.df("do_TencentWX",{"isWXAppInstalled":[]},{"login":["appId"],"pay":["appId","partnerId","prepayId","package","nonceStr","timeStamp","sign"],"share":["appId","scene","type","title","content","url","image","audio","trumb"]});UI.df("do_TextField",["clearAll","enterText","maxLength","textAlign","textFlag"],["clearImg","cursorColor","enabled","fontColor","fontSize","fontStyle","hint","hintColor","inputType","password","text"],{"setFocus":["value"],"setSelection":["position"]},{});MM.df("do_Timer",[],["delay","interval"],{"isStart":[],"start":[],"stop":[]},{});UI.df("do_ViewShower",[],[],{"addViews":["data"],"getView":["id"],"removeView":["id"],"showView":["id","animationType","animationTime"]},{});UI.df("do_WebView",["headerView","isHeaderVisible","isShowLoadingProgress","zoom"],["allowDeviceOne","allowVideoFullScreenPlayback","bounces","cacheType","url","userAgent"],{"back":[],"canBack":[],"canForward":[],"forward":[],"getContentSize":[],"rebound":[],"reload":[],"setCookie":["url","value"],"setDefaultEncodingURL":["isEncode"],"setLoadingProgressColor":["color"],"stop":[]},{"eval":["code"],"loadString":["text"]});SM.df("M1354_sms",{},{"getSupportedCountries":[],"getVerificationCode":["country","phone"],"getVoiceVerifyCode":["country","phone"],"submitVerificationCode":["country","phone","code"]});return d1;
})(this);